<template>
  <div>
    <div class="container">
      <div class="level">
        <div class="level-left">
          <p class="1">
            You are logged in as {{ user }}
          </p>
        </div>
        <!-- <div class="level-right">
          <b-button
            icon-left="logout-variant"
          >
            Log Out
          </b-button>
          <a
            :href="logOutUrl"
          > <b-icon icon="logout-variant" />Log Out</a>
        </div> -->
      </div>
    </div>
    <section class="section has-background-zerow-blue-green">
      <div class="container">
        <div class="columns">
          <div class="column is-four-fifths">
            <h1 class="is-size-2 title has-text-white">
              Mobile Press
            </h1>
          </div>
          <div class="column">
            <div class="image is-128x128">
              <img
                :src="press"
                class="is-rounded filter-white"
              >
            </div>
          </div>
        </div>
        <div class="box">
          <h1 class="is-size-4 title has-text-zerow-green-dark">
            Fruit offered by Farmer
          </h1>
          <b-table :data="fruitOfferings">
            <b-table-column
              v-slot="props"
              field="fruit.name"
              label="Name"
            >
              {{ props.row.fruitOffering.fruits[0].name }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="fruit.quantity"
              label="Quantity"
            >
              {{ props.row.fruitOffering.fruits[0].quantity }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="fruit.expiry_date"
              label="Expiry Date"
            >
              {{ props.row.fruitOffering.fruits[0].expiry_date }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="state"
              label="State"
            >
              {{ props.row.state }}
            </b-table-column>
            <b-table-column v-slot="props">
              <span>
                <b-button
                  v-if="!(props.row.state === 'ACCEPTED')"
                  class="button is-success"
                  @click="acceptFruit(props.row.id)"
                >Accept
                  Fruit</b-button>
              </span>
            </b-table-column>
            <template #empty>
              <div class="has-text-centered">
                No records
              </div>
            </template>
          </b-table>
        </div>
        <div class="box">
          <h1 class="is-size-4 title has-text-zerow-green-dark">
            Juice offered to Food Bank
          </h1>
          <div class="block">
            <b-table :data="juiceOfferings">
              <b-table-column
                v-slot="props"
                field="juiceOffering.juices[0].name"
                label="Name"
              >
                {{ props.row.juiceOffering.juices[0].name }}
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="juice.quantity"
                label="Quantity"
              >
                {{ props.row.juiceOffering.juices[0].quantity }}
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="juice.expiry_date"
                label="Expiry Date"
              >
                {{ props.row.juiceOffering.juices[0].expiry_date }}
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="state"
                label="State"
              >
                {{ props.row.state }}
              </b-table-column>
              <template #empty>
                <div class="has-text-centered">
                  No records
                </div>
              </template>
            </b-table>
          </div> <div class="block">
            <card-component title="Offer juice to the food bank">
              <form>
                <div class="columns">
                  <div class="column">
                    <b-field
                      horizontal
                      label="Name"
                    >
                      <b-input
                        v-model="juiceObj.juice.name"
                        placeholder="Name"
                        required
                      />
                    </b-field>
                    <b-field
                      horizontal
                      label="Expiry Date"
                    >
                      <b-input
                        v-model="juiceObj.juice.expiry_date"
                        placeholder="2023-01-01"
                      />
                    </b-field>
                  </div>
                  <div class="column">
                    <b-field
                      horizontal
                      label="Quantity"
                    >
                      <b-input
                        v-model.number="juiceObj.juice.quantity"
                        placeholder="Quantity"
                        type="number"
                      />
                    </b-field>
                  </div>
                </div>
                <footer>
                  <b-button
                    class="button is-success"
                    :disabled="isJuiceDisabled"
                    @click="offerJuice"
                  >
                    Send
                  </b-button>
                </footer>
              </form>
            </card-component>
          </div>
        </div>
        <div class="box">
          <h1 class="is-size-4 title has-text-zerow-green-dark">
            Juice requested by Food Bank
          </h1>
          <b-table :data="juiceRequests">
            <b-table-column
              v-slot="props"
              field="fruit.name"
              label="Name"
            >
              {{ props.row.juiceRequest.juices[0].name }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="fruit.quantity"
              label="Quantity"
            >
              {{ props.row.juiceRequest.juices[0].quantity }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="state"
              label="State"
            >
              {{ props.row.state }}
            </b-table-column>
            <b-table-column v-slot="props">
              <span>
                <b-button
                  v-if="(props.row.state === 'REQUESTED')"
                  class="button is-success"
                  @click="acceptJuiceRequest(props.row.juiceRequest.id)"
                >Accept</b-button>
              </span>
              <span>
                <b-button
                  v-if="(props.row.state === 'REQUESTED')"
                  class="button is-danger"
                  @click="rejectJuiceRequest(props.row.juiceRequest.id)"
                >Reject</b-button>
              </span>
            </b-table-column>
            <template #empty>
              <div class="has-text-centered">
                No records
              </div>
            </template>
          </b-table>
        </div>
        <div class="box">
          <h1 class="is-size-4 title has-text-zerow-green-dark">
            Fruit requested
          </h1>
          <b-table :data="fruitRequests">
            <b-table-column
              v-slot="props"
              field="fruit.name"
              label="Name"
            >
              {{ props.row.fruit_request.fruits[0].name }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="fruit.quantity"
              label="Quantity"
            >
              {{ props.row.fruit_request.fruits[0].quantity }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="state"
              label="State"
            >
              {{ props.row.state }}
            <!-- <span>
              <b-icon
                :icon="props.row.offered ? 'check-bold': 'cancel'"
              />
            </span> -->
            </b-table-column>
            <template #empty>
              <div class="has-text-centered">
                No records
              </div>
            </template>
          </b-table>

          <card-component title="Ask the farmer for fruits.">
            <form>
              <div class="columns">
                <div class="column">
                  <b-field
                    horizontal
                    label="Name"
                  >
                    <b-input
                      v-model="fruitObj.fruit.name"
                      placeholder="Name"
                      required
                    />
                  </b-field>
                </div>
                <div class="column">
                  <b-field
                    horizontal
                    label="Quantity"
                  >
                    <b-input
                      v-model.number="fruitObj.fruit.quantity"
                      placeholder="Quantity"
                      type="number"
                    />
                  </b-field>
                </div>
              </div>
              <footer>
                <b-button
                  class="button is-success"
                  :disabled="isFruitDisabled"
                  @click="requestFood"
                >
                  Send
                </b-button>
              </footer>
            </form>
          </card-component>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import { defineComponent } from '@vue/composition-api'
import axios from 'axios'
import CardComponent from '@/components/CardComponent.vue'
import press from '@/assets/press.svg'
import { v4 as uuidv4 } from 'uuid'

export default defineComponent({
  name: 'Home',
  components: {
    CardComponent
  },
  data () {
    return {
      api: axios.create({
        baseURL: 'api/',
        timeout: 5000
      }),
      press: press,
      fruitOfferings: [],
      juiceOfferings: [],
      juiceRequests: [],
      fruitRequests: [],
      fruitObj: {
        id: '',
        fruit: {
          name: '',
          quantity: 0,
          price: 0.0,
          expiry_date: ''
        }

      },
      juiceObj: {
        id: '',
        juice: {
          name: '',
          quantity: 0,
          expiry_date: ''
        }

      },
      uuidv4: uuidv4,
      user: '',
      logOutUrl: '',
      titleStack: ['Admin', 'ZeroW']
    }
  },
  computed: {
    isJuiceDisabled () {
      return !this.juiceObj.juice.name || !this.juiceObj.juice.expiry_date
    },
    isFruitDisabled () {
      return !this.fruitObj.fruit.name || !this.fruitObj.fruit.quantity
    }
  },
  created: async function () {
    await this.getUser()
    await this.fetchFruitOfferings()
    await this.fetchJuiceOfferings()
    await this.fetchFruitRequests()
    await this.fetchJuiceRequests()
  },
  methods: {
    getUser: async function () {
      const resp = await this.api.get('/press/user/')
      this.user = resp.data.user
      this.logOutUrl = resp.data.logOutUrl
    },
    fetchFruitOfferings: async function () {
      const resp = await this.api.get('/press/fruitOfferings/')
      this.fruitOfferings = resp.data
    },
    fetchFruitRequests: async function () {
      const resp = await this.api.get('/press/fruitRequests/')
      console.log(resp.data)
      this.fruitRequests = resp.data
    },
    fetchJuiceRequests: async function () {
      const resp = await this.api.get('/press/juiceRequests/')
      this.juiceRequests = resp.data
    },
    fetchJuiceOfferings: async function () {
      const resp = await this.api.get('/press/juiceOfferings/')
      console.log(resp.data)
      this.juiceOfferings = resp.data
    },
    requestFood: async function (fruit) {
      this.fruitObj.id = this.uuidv4()
      const resp = await this.api.post('/press/fruitRequests/',
        {
          id: this.fruitObj.id,
          fruits: [
            this.fruitObj.fruit
          ]
        }, {
          headers: {
            'content-type': 'application/json'
          }
        }

      )
      if (resp.status === 200) {
        await this.fetchFruitRequests()
      }
    },
    offerJuice: async function () {
      this.juiceObj.id = this.uuidv4()
      const resp = await this.api.post('/press/juiceOfferings/',
        {
          id: this.juiceObj.id,
          juices: [
            this.juiceObj.juice
          ]
        }, {
          headers: {
            'content-type': 'application/json'
          }
        }

      )
      if (resp.status === 200) {
        await this.fetchJuiceOfferings()
      }
    },
    acceptJuiceRequest: async function (requestId) {
      const resp = await this.api.post('/press/acceptJuiceRequest/', requestId, {
        headers: {
          'content-type': 'application/json'
        }
      })
      if (resp.status === 200) {
        await this.fetchJuiceRequests()
      }
    },
    rejectJuiceRequest: async function (requestId) {
      const resp = await this.api.post('/press/rejectJuiceRequest/', requestId, {
        headers: {
          'content-type': 'application/json'
        }
      })
      if (resp.status === 200) {
        await this.fetchJuiceRequests()
      }
    },
    acceptFruit: async function (requestId) {
      const resp = await this.api.post('/press/acceptFruits/', requestId, {
        headers: {
          'content-type': 'application/json'
        }
      })
      if (resp.status === 200) {
        await this.fetchFruitOfferings()
      }
    }
  }
})
</script>
